
(require-extension tcp)

(define (with-tcp-io host port thunk)
  (receive (in out) (tcp-connect host port)
    (with-input-from-port in
      (lambda () (with-output-to-port out thunk)))))

(define (tcp-serve handler port . o)
  ((make-tcp-server
    (tcp-listen port)
    (lambda ()
      (receive (local remote) (tcp-addresses (current-input-port))
        (handler remote))))))
