
(require-extension (srfi 10000))

(common-module (common string-cursor)
  ((export string-cursor? string-start-cursor string-end-cursor
           string-cursor-start? string-cursor-end?
           string-cursor-substring string-cursor-next
           string-cursor-prev string-cursor-ref
           string-cursor-grapheme-next string-cursor-grapheme-prev
           string-cursor-grapheme-ref))

(define (string-cursor? x) (integer? x))

(define (string-start-cursor str) 0)

(define (string-end-cursor str) (string-length str))

(define (string-cursor-start? str c) (zero? c))

(define (string-cursor-end? str c)
  (>= c (string-length str)))

(define string-cursor-substring substring)

(define (string-cursor-next str c) (+ c 1))

(define (string-cursor-prev str c) (- c 1))

(define string-cursor-ref string-ref)

;; add full grapheme support later

(define string-cursor-grapheme-next string-cursor-next)

(define string-cursor-grapheme-prev string-cursor-prev)

(define string-cursor-grapheme-ref string-ref)

)
