
(define-module (common io))

(use-modules (ice-9 rdelim))

(export pr nl flush-output with-string-io read-line)

(define flush-output force-output)

(define (pr . args)
  (for-each display args))

(define nl #\newline)

(define (with-string-io str thunk)
  (with-output-to-string
    (lambda () (with-input-from-string str thunk))))
