
(require-extension (srfi 10000))

(common-module ()
 ((import-syntax (srfi testing))
  (import-extension (common io))
  (entry-point main))

(define (main args)

(test-begin "io")

(test-equal "hi\n" (with-output-to-string (lambda () (print 'hi))))
(test-equal "hi, bob\n" (with-output-to-string (lambda () (print 'hi #\, #\space "bob"))))

(test-equal "hi" (with-input-from-string "hi" (lambda () (read-line))))
(test-equal "hi" (with-input-from-string "hi\nalice" (lambda () (read-line))))

(test-equal "hi" (with-string-io "hi\nbob" (lambda () (display (read-line)))))

(test-end "io")

))
