
(require-extension (srfi 10000))

(common-module ()
 ((import-syntax (srfi testing))
  (import-extension (common test keywords))
  (entry-point main))

(define (main args)

(test-begin "keywords")

(test-equal '(1 2 3) (list-x-y-z))
(test-equal '(10 2 3) (list-x-y-z x: 10))
(test-equal '(1 20 3) (list-x-y-z y: 20))
(test-equal '(1 2 30) (list-x-y-z z: 30))
(test-equal '(10 20 3) (list-x-y-z y: 20 x: 10))
(test-equal '(1 20 30) (list-x-y-z z: 30 y: 20))
(test-equal '(10 20 30) (list-x-y-z y: 20 z: 30 x: 10))
(test-equal '(10 20 30) (apply list-x-y-z '(y: 20 z: 30 x: 10)))

(test-end "keywords")

))
