
(require-extension extras)

(define true #t)
(define false #f)

(define always-true (constantly #t))
(define always-false (constantly #f))

(define (fix proc init . opt)
  (let ((eq (if (pair? opt) (car opt) equal?)))
    (let loop ((x (proc init))
               (last init))
      (if (eq x last)
        x
        (loop (proc x) x)))))

(define (S f g x) ((f x) (g x)))
(define (K x y) x)
(define I identity)
(define (U x) (x x))
(define (Y gen)
  ((lambda (f) (f f))
   (lambda (f)
     (gen (lambda x (apply (f f) x))))))
