
(require-extension posix)

(define (current-implementation)
  'chicken)

;;getenv
;;setenv
;;unsetenv

(define current-host-name get-host-name)

(define (current-host-os)
  (nth-value 0 (system-information)))
(define (current-host-architecture)
  (nth-value 4 (system-information)))

;;current-user-id
;;current-group-id

(define (user-id->name id)
  (car (user-information id)))

(define (user-name->id name)
  (caddr (user-information name)))

(define (user-home . o)
  (let ((user (if (pair? o) (car o) (current-user-id))))
    (caddr (cdddr (user-information user)))))

(define (group-id->name id)
  (car (group-information id)))

(define (group-name->id name)
  (caddr (group-information name)))
