
(require-extension (srfi 10000))

(common-module (common io)
  ((export pr nl flush-output with-output-to-string with-string-io))

(define flush-output force-output)

(define (pr . args)
  (for-each display args))

(define nl #\newline)

(define with-output-to-string
  (let ((orig-with-output-to-string with-output-to-string))
    (lambda (x . o)
      (if (procedure? x)
        (orig-with-output-to-string "" x)
        (apply orig-with-output-to-string x o)))))

(define (with-string-io str thunk)
  (with-output-to-string
    (lambda ()
      (with-input-from-string str thunk))))

)
