
(require-extension (srfi 10000))

(common-module ()
 ((import-syntax (srfi testing))
  (import-extension (common test amphibian))
  (entry-point main))

(define (main args)

(test-begin "module multiple inheritance")

(test-assert (animal? (make-animal "bird")))
(test-assert (animal? (make-fish)))
(test-assert (animal? (make-mammal)))
(test-assert (animal? (make-reptile)))
(test-assert (reptile? (make-reptile)))
(test-assert (animal? (make-amphibian)))
(test-assert (amphibian? (make-amphibian)))

(test-end "module multiple inheritance")

))
